﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Anitoa.Pages
{
    /// <summary>
    /// ucTiaoShiThree.xaml 的交互逻辑
    /// </summary>
    public partial class ucTiaoShiThree : UserControl
    {
        public event EventHandler SaveConfigOK;
        public ucTiaoShiThree()
        {
            InitializeComponent();
            this.Loaded += ucTiaoShiThree_Loaded;
            this.Unloaded += ucTiaoShiThree_Unloaded;
        }

        void ucTiaoShiThree_Unloaded(object sender, RoutedEventArgs e)
        {
            if (CommData.currCycleState != 0)
                return;

            CommData.experimentModelData.gainMode[0] = cboGainChan1.SelectedIndex;
            CommData.experimentModelData.gainMode[1] = cboGainChan2.SelectedIndex;
            CommData.experimentModelData.gainMode[2] = cboGainChan3.SelectedIndex;
            CommData.experimentModelData.gainMode[3] = cboGainChan4.SelectedIndex;

            CommData.experimentModelData.IntTimeChan1 = (float)Convert.ToDouble(txtITChan1.Text);
            CommData.experimentModelData.IntTimeChan2 = (float)Convert.ToDouble(txtITChan2.Text);
            CommData.experimentModelData.IntTimeChan3 = (float)Convert.ToDouble(txtITChan3.Text);
            CommData.experimentModelData.IntTimeChan4 = (float)Convert.ToDouble(txtITChan4.Text);

            CommData.experimentModelData.IntTimeMaxChan1 = (float)Convert.ToDouble(txtITMaxChan1.Text);
            CommData.experimentModelData.IntTimeMaxChan2 = (float)Convert.ToDouble(txtITMaxChan2.Text);
            CommData.experimentModelData.IntTimeMaxChan3 = (float)Convert.ToDouble(txtITMaxChan3.Text);
            CommData.experimentModelData.IntTimeMaxChan4 = (float)Convert.ToDouble(txtITMaxChan4.Text);

            CommData.experimentModelData.AutoIntTargetPercent = 0.01f * Convert.ToSingle(txtAutoIntTargetGain.Text.ToString());

            SaveConfigOK("IntTimeUpdate", null);

            CommData.experimentModelData.CbooChan1 = cboChan1.IsChecked.Value;
            CommData.experimentModelData.CbooChan2 = cboChan2.IsChecked.Value;
            CommData.experimentModelData.CbooChan3 = cboChan3.IsChecked.Value;
            CommData.experimentModelData.CbooChan4 = cboChan4.IsChecked.Value;

        }

        void ucTiaoShiThree_Loaded(object sender, RoutedEventArgs e)
        {
            rbjd3.IsChecked = true;

            if (CommData.currCycleState != 0)
                return;

            SaveConfig();

            // txtCrossTalk12.Text = (100 * CommData.experimentModelData.crossTalk12).ToString("0.0");

            txtOverShootTemp.Text = CommData.experimentModelData.overTemp.ToString("0.0");
            txtUnderShootTemp.Text = CommData.experimentModelData.underTemp.ToString("0.0");
            txtOverShootTime.Text = CommData.experimentModelData.overTime.ToString("0.0");
            txtUnderShootTime.Text = CommData.experimentModelData.underTime.ToString("0.0");

            cboGainChan1.SelectedIndex = CommData.experimentModelData.gainMode[0];
            cboGainChan2.SelectedIndex = CommData.experimentModelData.gainMode[1];
            cboGainChan3.SelectedIndex = CommData.experimentModelData.gainMode[2];
            cboGainChan4.SelectedIndex = CommData.experimentModelData.gainMode[3];

            txtITChan1.Text = CommData.experimentModelData.IntTimeChan1.ToString("0.0");    // CommData.int_time_1.ToString("0.0");
            txtITChan2.Text = CommData.experimentModelData.IntTimeChan2.ToString("0.0");    // CommData.int_time_2.ToString("0.0");
            txtITChan3.Text = CommData.experimentModelData.IntTimeChan3.ToString("0.0");    // CommData.int_time_3.ToString("0.0");
            txtITChan4.Text = CommData.experimentModelData.IntTimeChan4.ToString("0.0");    // CommData.int_time_4.ToString("0.0");

            txtITMaxChan1.Text = CommData.experimentModelData.IntTimeMaxChan1.ToString("0.0");    // 
            txtITMaxChan2.Text = CommData.experimentModelData.IntTimeMaxChan2.ToString("0.0");    // 
            txtITMaxChan3.Text = CommData.experimentModelData.IntTimeMaxChan3.ToString("0.0");    // 
            txtITMaxChan4.Text = CommData.experimentModelData.IntTimeMaxChan4.ToString("0.0");    // 

            EnAutoInt.IsChecked = CommData.experimentModelData.enAutoInt;

            txtAutoIntTargetGain.Text = (100 * CommData.experimentModelData.AutoIntTargetPercent).ToString("0.0");

            cboChan1.IsChecked = CommData.experimentModelData.CbooChan1;
            cboChan2.IsChecked = CommData.experimentModelData.CbooChan2;
            cboChan3.IsChecked = CommData.experimentModelData.CbooChan3;
            cboChan4.IsChecked = CommData.experimentModelData.CbooChan4;
        }

        private void RadioButton_Click(object sender, RoutedEventArgs e)
        {
            RadioButton rb = sender as RadioButton;

            switch (rb.Name)
            {
                case "rbSave":
                    SaveConfig();
                    // CommData.AddExperiment(CommData.experimentModelData);
                    break;
                case "rbReadTemp":
                    if (SaveConfigOK != null)
                    {
                        SaveConfigOK("ReadTemp", null);
                    }
                    break;
                case "rbOverShoot":
                    if (SaveConfigOK != null)
                    {
                        SaveConfigOK("OverShoot", null);
                    }
                    break;
            }
        }

        public void SetPTTemp()
        { 
        
        }


        public void SetPITemp()
        {

        }

        private void SaveConfig()
        {
            try
            {
                DebugModelData DebugModelData = new DebugModelData();
                //DebugModelData.Annealing = Convert.ToDouble(txtAnnealing.Text);
                //DebugModelData.AnnealingTime = Convert.ToDouble(txtAnnealingTime.Text);
                //DebugModelData.Cycle = Convert.ToInt32(txtCycle.Text);
                //DebugModelData.Denaturating = Convert.ToDouble(txtDenaturating.Text);
                //DebugModelData.DenaturatingTime = Convert.ToDouble(txtDenaturatingTime.Text);
                //DebugModelData.Extension = Convert.ToDouble(txtExtension.Text);
                //DebugModelData.ExtensionTime = Convert.ToDouble(txtExtensionTime.Text);
                //DebugModelData.Holdon = Convert.ToDouble(txtHoldon.Text);
                //DebugModelData.HoldonTime = Convert.ToDouble(txtHoldonTime.Text);
                //DebugModelData.Hotlid = Convert.ToDouble(txtHotlid.Text);
                //DebugModelData.InitaldenaTime = Convert.ToDouble(txtInitaldenaTime.Text);
                //DebugModelData.Initaldenaturation = Convert.ToDouble(txtInitaldenaturation.Text);
                //DebugModelData.StepCount = 3;
                //DebugModelData.InitDenatureStepCount = 1;

                if (SaveConfigOK != null)
                {
                    // SaveConfigOK(DebugModelData, null);              // 12-25-2020 Change by Zhimin, do nothing
                }
            }
            catch (Exception ex)
            {

            }          
        }

        private void rbjd1_Checked(object sender, RoutedEventArgs e)
        {
            RadioButton rb = sender as RadioButton;
            switch(rb.Name)
            {
                case "rbjd1":
                    CommData.CurrPZJD = 1;
                    break;
                case "rbjd2":
                    CommData.CurrPZJD = 2;
                    break;
                case "rbjd3":
                    CommData.CurrPZJD = 3;
                    break;
            }
        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            CommData.experimentModelData.enAutoInt = true;
        }

        private void CheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            CommData.experimentModelData.enAutoInt = false;
        }

        //private void cboChan1_Checked(object sender, RoutedEventArgs e)
        //{

        //}

        //private void cboChan1_Unchecked(object sender, RoutedEventArgs e)
        //{

        //}

        private void cboChan1_Checked(object sender, RoutedEventArgs e)
        {
            CheckBox cb = sender as CheckBox;
            switch (cb.Name)
            {
                case "cboChan1":
                    CommData.cboChan1 = 1;
                    break;
                case "cboChan2":
                    CommData.cboChan2 = 1;
                    break;
                case "cboChan3":
                    CommData.cboChan3 = 1;
                    break;
                case "cboChan4":
                    CommData.cboChan4 = 1;
                    break;
            }
        }

        private void cboChan1_Unchecked(object sender, RoutedEventArgs e)
        {
            CheckBox cb = sender as CheckBox;
            switch (cb.Name)
            {
                case "cboChan1":
                    CommData.cboChan1 = 0;
                    break;
                case "cboChan2":
                    CommData.cboChan2 = 0;
                    break;
                case "cboChan3":
                    CommData.cboChan3 = 0;
                    break;
                case "cboChan4":
                    CommData.cboChan4 = 0;
                    break;
            }
        }

        /*
        public void Clear()
        {
            txtPt.Text = "";
            txtPi.Text = "";
        }

        private void rbClear_Click(object sender, RoutedEventArgs e)
        {
            Clear();
        }
        */
    }
}
